
Quests = {}
Quests.Quests = {}
local MeineQuests = {}
local QuestCount
local Settings = { showDaily = true }

SLASH_QUESTS1 = "/quests"

SlashCmdList["QUESTS"] = function (editBox, msg)
	local frame = UndoneQuestsFrame
	if frame:IsVisible() then
		frame:Hide()
	else
		frame:Show()
	end
end

Quests.OnLoad = function (this)
	SaveVariablesPerCharacter("MeineQuests")
	this:RegisterEvent("VARIABLES_LOADED")
	this:RegisterEvent("SAVE_VARIABLES")
	this:RegisterEvent("ADDNEW_QUESTBOOK")
	this:RegisterEvent("RESET_QUESTBOOK")
	this:RegisterEvent("QUEST_COMPLETE")
	
	local info = {
		columnTemplate		= "QuestsColumnTemplate", 
		itemTemplate		= "QuestsListItemTemplate",
		messageBarTemplate	= "QuestsMessageBarTemplate",
		itemCount			= 15,
		
		itemHorizontalLine = 1,
		itemHorizontalLineStatic = 1,

		scrollBarStatic = 1,
		scrollBarType = 1,

		callbackFunc_GetCount = function (listFrame)
			QuestCount =  Quests.QuestUpdate()
			getglobal(listFrame.messageBar:GetName() .. "_Text"):SetText("Gesamtzahl unerledigter Quests: ".. QuestCount)
			return QuestCount
			
		end,
		callbackFunc_UpdateItme = function (listFrame, item, index)
			if Quests.Quests[index] then
				item.qid = Quests.Quests[index][1]
				getglobal(item:GetName() .. "_ID"):SetText(Quests.Quests[index][1])
				item.qname = Quests.Quests[index][2]
				getglobal(item:GetName() .. "_Name"):SetText(Quests.Quests[index][2])
			end
		end,
	}
	UIPanelCommonListFrame_Init(UndoneQuestsFrameListFrame, info)
	Quests.ListFrame_SetColumn( getglobal(UndoneQuestsFrameListFrame.column:GetName() .. "_ID" ),	"ID")
	Quests.ListFrame_SetColumn( getglobal(UndoneQuestsFrameListFrame.column:GetName() .. "_Name" ),	"Name")
end

Quests.ListFrame_SetColumn = function (column, text)
	if (text) then
		getglobal(column:GetName() .. "_Label"):SetText(text)
		column:Show()
	else
		column:Hide()
	end
end

Quests.OnEvent = function (this, event)
	if event == "VARIABLES_LOADED" then
		if DailyNotes.DB_Quests then
			Quests.DailyTable = DailyNotes.DB_Quests
		else
			Quests.DailyTable = {}
		end
		if MeineQuests and MeineQuests.Settings then
			Settings = MeineQuests.Settings
		end
		UndoneQuestsFrameShowDailyCheckbutton:SetChecked(Settings.showDaily)
		--Quests.QuestUpdate()
	elseif event == "SAVE_VARIABLES" then
		MeineQuests.Quests = Quests.Quests
		MeineQuests.Settings = Settings
	elseif event == "ADDNEW_QUESTBOOK" or event == "RESET_QUESTBOOK" and arg2 == 0 or event == "QUEST_COMPLETE" then
		QuestCount = nil
	end
end

Quests.OnShow = function (this)
	UndoneQuestsFrameListFrame:Update()
end

Quests.OnShowDailyToggle = function (this)
	Settings.showDaily = this:IsChecked()
	Quests.QuestUpdate(true)
	UndoneQuestsFrameListFrame:Update()
end

Quests.OnEnter = function (this)
	local x, y = UndoneQuestsFrame:GetPos()
	if(x <= 600) then
		GameTooltip:SetOwner( UndoneQuestsFrame, "ANCHOR_RIGHT", 0, 4)
	else	
		GameTooltip:SetOwner( UndoneQuestsFrame, "ANCHOR_LEFT", 0, 4)
	end
	GameTooltip:SetHyperLink(string.format("|Hquest:%x|h%s|h", this.qid, this.qname))
end

Quests.OnClick = function (this)
	ChatEdit_AddItemLink(string.format("|Hquest:%x|h|cff0000ff[%s]|r|h", this.qid, this.qname))
end

Quests.OnDoubleClick = function (this)
	StaticPopupDialogs["OPEN_WEBROWER"].link = "https://database.rom-welten.de/index.php?lang=eneu&db=questdetailobject&guid="..this.qid
	StaticPopup_Show("OPEN_WEBROWER")
end

Quests.QuestUpdate = function (doRefresh)
	if doRefresh then QuestCount = nil end
	if QuestCount then return QuestCount end
	Quests.Quests = {}
	for id = 420000, 429999 do
		local sys = "Sys" .. id .. "_name";
		local name = TEXT(sys);
		if (name ~= nil) and (name ~= "") and (name ~= sys) then		
			local status = CheckQuest(id);
			if (status == 0) then
				if Quests.DailyTable[id] and (Quests.DailyTable[id]["typ"]%10)%3 ~= 0 then -- not type 3 or 6
					if Settings.showDaily then
						table.insert(Quests.Quests, {id, "[D] " .. name})
					end
				else
					table.insert(Quests.Quests, {id, name})
				end
			end
		end
	end
	return #Quests.Quests
end